package cn.com.qmth.examcloud.core.questions.service.util;

import java.util.concurrent.ThreadLocalRandom;

public class RandomNumberUtil {

    /**
     * 获取[0,maxNum]的takeCount个数字
     * 
     * @param maxNum
     *            随机获取的最大数字
     * @param takeCount
     *            随机获取的数量
     */
    public static int[] randomTake(int maxNum, int takeCount) {
        if (takeCount <= 0) {
            throw new RuntimeException("获取数量必须大于0");
        }
        if (maxNum < 0) {
            throw new RuntimeException("最大数字不能小于0");
        }
        if (maxNum + 1 < takeCount) {
            throw new RuntimeException("最大数字+1不能小于获取数量");
        }

        // 0到maxNum的全量数字
        int[] indexs = new int[maxNum + 1];

        for (int i = 0; i <= maxNum; i++) {
            indexs[i] = i;
        }

        // 结果集存放
        int[] ret = new int[takeCount];

        for (int i = 0; i < takeCount; i++) {
            // 获取随机数，范围[i,maxNum + 1),作为indexs数组的下标
            int randomIndex = ThreadLocalRandom.current().nextInt(i, maxNum + 1);
            // 存入结果集
            ret[i] = indexs[randomIndex];
            // 和第i个元素交换获取的随机元素,下一轮获取随机数的下标就排除了第i个元素，也就是交换之后的randomIndex
            int temp = indexs[i];
            indexs[i] = indexs[randomIndex];
            indexs[randomIndex] = temp;
        }

        return ret;
    }

}
